/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.ac.leeds.ccg.andyt.grids.core;

import java.io.File;
import java.io.Serializable;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import uk.ac.leeds.ccg.andyt.grids.core.AbstractGrid2DSquareCell.ChunkID;

/**
 *
 * @author Andy
 */
public class Grids_Environment
        extends Grids_OutOfMemoryErrorHandler
        implements Serializable, Grids_OutOfMemoryErrorHandlerInterface {

    /**
     * Local _Directory used for caching.
     * TODO
     * If this were not transient upon reloading, it would be possible to
     * ascertain what it was which might be useful.
     */
    protected transient File _Directory;
    /**
     * A HashSet of AbstractGrid2DSquareCell objects that
     * have data that can be swapped to release memory for
     * processing.
     */
    protected transient HashSet<AbstractGrid2DSquareCell> _AbstractGrid2DSquareCell_HashSet;

    public Grids_Environment() {
        init_AbstractGrid2DSquareCell_HashSet();
    }

//    /**
//     * A HashSet of AbstractGrid2DSquareCell objects that
//     * have data that can be swapped to release memory for
//     * processing.
//     */
//    protected transient HashSet<AbstractGrid2DSquareCell> _AbstractGrid2DSquareCell_HashSet;
//
//        /**
//     * A HashSet of AbstractGrid2DSquareCell objects that
//     * have data that can be swapped to release memory for
//     * processing.
//     */
//    protected transient HashSet<AbstractGrid2DSquareCell> _AbstractGrid2DSquareCell_HashSet;
    /**
     * Initialises _AbstractGrid2DSquareCell_HashSet
    <code>
    if ( this._AbstractGrid2DSquareCell_HashSet == null ) {
    this._AbstractGrid2DSquareCell_HashSet = new HashSet<AbstractGrid2DSquareCell>();
    }
    </code>
     */
    protected void init_AbstractGrid2DSquareCell_HashSet() {
        if (this._AbstractGrid2DSquareCell_HashSet == null) {
            this._AbstractGrid2DSquareCell_HashSet = new HashSet<AbstractGrid2DSquareCell>();
        }
    }

    /**
     * Initialises _AbstractGrid2DSquareCell_HashSet
     * <code>
    if ( this._AbstractGrid2DSquareCell_HashSet == null ) {
    this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
    } else {
    //System.err.println( this.getClass().getName() + ".init_AbstractGrid2DSquareCell_HashSet(HashSet)" );
    if ( a_AbstractGrid2DSquareCell_HashSet == null ) { // Debug
    this._AbstractGrid2DSquareCell_HashSet = new HashSet();
    } else {
    this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
    }
    }
     * </code>
     */
    protected void init_AbstractGrid2DSquareCell_HashSet(
            HashSet<AbstractGrid2DSquareCell> a_AbstractGrid2DSquareCell_HashSet) {
        if (this._AbstractGrid2DSquareCell_HashSet == null) {
            this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
        } else {
            //System.err.println( this.getClass().getName() + ".init_AbstractGrid2DSquareCell_HashSet(HashSet)" );
            if (a_AbstractGrid2DSquareCell_HashSet == null) { // Debug
                this._AbstractGrid2DSquareCell_HashSet = new HashSet<AbstractGrid2DSquareCell>();
            } else {
                this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
            }
        }
    }

    /**
     * @return this._AbstractGrid2DSquareCell_HashSet.
     */
    public HashSet<AbstractGrid2DSquareCell> get_AbstractGrid2DSquareCell_HashSet() {
        return this._AbstractGrid2DSquareCell_HashSet;
    }

    /**
     * Sets this._AbstractGrid2DSquareCell_HashSet to _AbstractGrid2DSquareCell_HashSet
     * @param _AbstractGrid2DSquareCell_HashSet The HashSet this._AbstractGrid2DSquareCell_HashSet is set to.
     */
    public void set_AbstractGrid2DSquareCell_HashSet(
            HashSet<AbstractGrid2DSquareCell> a_AbstractGrid2DSquareCell_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
            tryToEnsureThereIsEnoughMemoryToContinue(handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunk_Account() < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(handleOutOfMemoryError);
                set_AbstractGrid2DSquareCell_HashSet(
                        a_AbstractGrid2DSquareCell_HashSet,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
     */
    protected void set_AbstractGrid2DSquareCell_HashSet(
            HashSet<AbstractGrid2DSquareCell> a_AbstractGrid2DSquareCell_HashSet) {
        this._AbstractGrid2DSquareCell_HashSet = a_AbstractGrid2DSquareCell_HashSet;
    }

    /**
     * @param _AbstractGrid2DSquareCell_HashSet A HashSet used for initialisation.
     */
    public void init_Grid2DSquareCells_MemoryReserve(
            HashSet<AbstractGrid2DSquareCell> a_AbstractGrid2DSquareCell_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            init_Grid2DSquareCells_MemoryReserve(a_AbstractGrid2DSquareCell_HashSet);
            tryToEnsureThereIsEnoughMemoryToContinue(handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunk_Account() < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_Grid2DSquareCells_MemoryReserve(
                        a_AbstractGrid2DSquareCell_HashSet,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @param _AbstractGrid2DSquareCell_HashSet A HashSet used for initialisation.
     */
    protected void init_Grid2DSquareCells_MemoryReserve(
            HashSet<AbstractGrid2DSquareCell> a_AbstractGrid2DSquareCell_HashSet) {
        init_AbstractGrid2DSquareCell_HashSet(a_AbstractGrid2DSquareCell_HashSet);
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        if (a_Iterator.hasNext()) {
            a_Iterator.next()._Grids_Environment.set_MemoryReserve(get_MemoryReserve());
        } else {
            init_MemoryReserve();
        }
        //System.err.println( this.getClass().getName() + ".init_Grid2DSquareCells_MemoryReserve(HashSet)" );
    }

    /**
     * Initialises _MemoryReserve.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunk_AccountDetail();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentailPartResult =
                        init_MemoryReserve_AccountDetail(
                        handleOutOfMemoryError);
                combine(result,
                        potentailPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunk_Account();
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls swapToFile_Grid2DSquareCellChunksExcept_Account(_Grid2DSquareCell)
     * (if that returns null then it calls swapToFile_Grid2DSquareCellChunk())
     * then recurses.
     * @param a_Grid2DSquareCell
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public final void init_MemoryReserve(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            tryToEnsureThereIsEnoughMemoryToContinue(
                    a_Grid2DSquareCell,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell) < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_ChunkID,handleOutOfMemoryError)
     * then recurses.
     * @param a_ChunkID
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public final void init_MemoryReserve(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            tryToEnsureThereIsEnoughMemoryToContinue(
                    a_ChunkID,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_ChunkID) < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_ChunkID,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_ChunkID,handleOutOfMemoryError)
     * then recurses.
     * @param a_ChunkID
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_ChunkID,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_ChunkID);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_ChunkID,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_ChunkID);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_Grid2DSquareCell,_ChunkID,handleOutOfMemoryError)
     * then recurses.
     * @param a_Grid2DSquareCell
     * @param a_ChunkID
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public final void init_MemoryReserve(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            tryToEnsureThereIsEnoughMemoryToContinue(handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID) < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_Grid2DSquareCell,_ChunkID,handleOutOfMemoryError)
     * then recurses.
     * @param a_Grid2DSquareCell
     * @param a_ChunkID
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell,
                    a_ChunkID,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public long init_MemoryReserve_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_Grid2DSquareCell,a_ChunkID_HashSet,handleOutOfMemoryError)
     * then recurses.
     * @param a_Grid2DSquareCell
     * @param a_ChunkID_HashSet HashSet of AbstractGrid2DSquareCell.ChunkIDs
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public final void init_MemoryReserve(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            tryToEnsureThereIsEnoughMemoryToContinue(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet) < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Initialises _MemoryReserve. If an OutOfMemoryError is encountered
     * this calls
     * swapToFile_Grid2DSquareCellChunksExcept_AccountSuccess(_Grid2DSquareCell_ChunkIDHashSet,handleOutOfMemoryError)
     * then recurses.
     * @param _Grid2DSquareCell_ChunkIDHashSet_HashMap HashMap with AbstractGrid2DSquareCell as
     * keys and a respective HashSet of AbstractGrid2DSquareCell.ChunkIDs. Identifying
     * those ChunkIDs not to be swapped from the AbstractGrid2DSquareCell.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught, swap operations are initiated,
     *     then the method is re-called.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    @Override
    public void init_MemoryReserve(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            tryToEnsureThereIsEnoughMemoryToContinue(
                    a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) < 1) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> init_MemoryReserve_AccountDetail(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            init_MemoryReserve();
            return tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                    handleOutOfMemoryError);
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * A method to try to ensure there is enough memory to continue. If not
     * enough data is found to swap then an OutOfMemoryError is thrown.
     */
    @Override
    public boolean tryToEnsureThereIsEnoughMemoryToContinue(
            boolean handleOutOfMemoryError) {
        try {
            if (tryToEnsureThereIsEnoughMemoryToContinue()) {
                return true;
            } else {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue(boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (!tryToEnsureThereIsEnoughMemoryToContinue()) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        handleOutOfMemoryError);
                return true;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    protected boolean tryToEnsureThereIsEnoughMemoryToContinue() {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunk_Account() < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to try to ensure there is enough memory to continue. No data is
     * swapped from a_Grid2DSquareCell. If not enough data is found to swap then
     * an OutOfMemoryError is thrown.
     */
    @Override
    public void tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            if (tryToEnsureThereIsEnoughMemoryToContinue(a_Grid2DSquareCell)) {
                return;
            } else {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue(AbstractGrid2DSquareCell,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean isEnoughMemoryToContinue = tryToEnsureThereIsEnoughMemoryToContinue(
                        a_Grid2DSquareCell);
                if (!isEnoughMemoryToContinue) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected boolean tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell) < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to try to ensure there is enough memory to continue. The Chunk
     * with a_ChunkID from a_Grid2DSquareCell is not swapped. If not enough data
     * is found to swap then an OutOfMemoryError is thrown.
     */
    @Override
    public void tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            if (tryToEnsureThereIsEnoughMemoryToContinue(a_Grid2DSquareCell, a_ChunkID)) {
                return;
            } else {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue(AbstractGrid2DSquareCell,ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean isEnoughMemoryToContinue = tryToEnsureThereIsEnoughMemoryToContinue(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (!isEnoughMemoryToContinue) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected boolean tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID) < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to try to ensure there is enough memory to continue. No data is
     * swapped with a_ChunkID. If not enough data is found to swap then an
     * OutOfMemoryError is thrown.
     */
    @Override
    public void tryToEnsureThereIsEnoughMemoryToContinue(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            if (tryToEnsureThereIsEnoughMemoryToContinue(a_ChunkID)) {
                return;
            } else {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue(ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean isEnoughMemoryToContinue = tryToEnsureThereIsEnoughMemoryToContinue(
                        a_ChunkID);
                if (!isEnoughMemoryToContinue) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_ChunkID,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected boolean tryToEnsureThereIsEnoughMemoryToContinue(
            ChunkID a_ChunkID) {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_ChunkID) < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to try to ensure there is enough memory to continue. No data is
     * swapped as identified by
     * a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap. If not enough data
     * is found to swap then an OutOfMemoryError is thrown.
     */
    @Override
    public void tryToEnsureThereIsEnoughMemoryToContinue(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            if (tryToEnsureThereIsEnoughMemoryToContinue(a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap)) {
                return;
            } else {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue(HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean isEnoughMemoryToContinue = tryToEnsureThereIsEnoughMemoryToContinue(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
                if (!isEnoughMemoryToContinue) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected boolean tryToEnsureThereIsEnoughMemoryToContinue(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to ensure there is enough memory to continue. No data is swapped
     * in a_Grid2DSquareCell that has ChunkID in a_ChunkID_HashSet.
     * @param handleOutOfMemoryError
     */
    @Override
    public void tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID_HashSet) < 1) {
                    System.out.println(
                            "Warning! Nothing to swap in "
                            + this.getClass().getName()
                            + ".tryToEnsureThereIsEnoughMemoryToContinue(AbstractGrid2DSquareCell,HashSet<ChunkID>,boolean)");
                    // Set to exit method with OutOfMemoryError
                    handleOutOfMemoryError = false;
                    throw new OutOfMemoryError();
                }
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean createdRoom = false;
                while (!createdRoom) {
                    if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID_HashSet) < 1L) {
                        System.out.println(
                                "Warning! Nothing to swap in "
                                + this.getClass().getName()
                                + ".tryToEnsureThereIsEnoughMemoryToContinue(AbstractGrid2DSquareCell,HashSet<ChunkID>,boolean) after encountering an OutOfMemoryError");
                        throw a_OutOfMemoryError;
                    }
                    init_MemoryReserve(
                            a_Grid2DSquareCell,
                            a_ChunkID_HashSet,
                            handleOutOfMemoryError);
                    tryToEnsureThereIsEnoughMemoryToContinue(
                            a_Grid2DSquareCell,
                            a_ChunkID_HashSet,
                            handleOutOfMemoryError);
                    createdRoom = true;
                }
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected boolean tryToEnsureThereIsEnoughMemoryToContinue(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        while (getTotalFreeMemory() < Memory_Threshold) {
            if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID_HashSet) < 1) {
                return false;
            }
        }
        return true;
    }

    /**
     * A method to ensure there is enough memory to continue. An attempt at
     * Grids internal memory handling is performed if an OutOfMemoryError is
     * encountered and handleOutOfMemoryError is true. This method may throw
     * an OutOfMemoryError if there is not enough data to swap in Grids.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account();
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * A method to try to ensure there is enough memory to continue. This method
     * quickly returns null if there is enough memory to continue. If there is
     * not enough memory to continue it will attempt to make room. If
     * successful, this will return an Object[] with the first element being a
     * Boolean with value true. The second element being a
     * HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> indicating the data
     * that was swapped. If unsuccessful, this will return an Object[] with the
     * first element being a Boolean with value false. The second element being
     * a HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> indicating the data
     * that was swapped.
     * @return Either null or an Object[] of length 2 with first element a
     * Boolean and second element a
     * HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>.
     */
    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account() {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunk_Account() < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. No data is swapped
     * from a_Grid2DSquareCell.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell);
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(AbstractGrid2DSquareCell,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell) < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. The Chunk with
     * a_ChunkID from a_Grid2DSquareCell is not swapped.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID);
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(AbstractGrid2DSquareCell,ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID) < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. No data is swapped
     * with a_ChunkID.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_ChunkID);
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        a_ChunkID,
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account(
            ChunkID a_ChunkID) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_ChunkID) < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. No data is swapped
     * as identified by a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. No data is swapped
     * as identified by a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     */
    @Override
    public long tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet);
            if (test == null) {
                return 0;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_Account(AbstractGrid2DSquareCell,HashSet<ChunkID>,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (Long) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public Object[] tryToEnsureThereIsEnoughMemoryToContinue_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            long result1 = 0L;
            while (getTotalFreeMemory() < Memory_Threshold) {
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(a_Grid2DSquareCell, a_ChunkID_HashSet) < 1) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    result1++;
                }
            }
            result[0] = true;
            result[1] = result1;
            return result;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. An attempt at
     * Grids internal memory handling is performed if an OutOfMemoryError is
     * encountered and handleOutOfMemoryError is true. This method may throw
     * an OutOfMemoryError if there is not enough data to swap in Grids.
     * @param handleOutOfMemoryError
     * @return Number of chunks swapped.
     * A method to ensure there is enough memory to continue. For this to work
     * accounting must be less expesive in terms of data size than swapping
     * data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail();
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * A method to ensure there is enough memory to continue. This method will
     * quickly return null if there is enough memory to continue. If there is
     * not enough memory to continue it will attempt to make room. If
     * successful, this will return an Object[] with the first element being a
     * Boolean with value true. The second element being a
     * HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> indicating the data
     * that was swapped. If unsuccessful, this will return an Object[] with the
     * first element being a Boolean with value false. The second element being
     * a HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> indicating the data
     * that was swapped.
     * @return Either null or an Object[] of length 2 with first element a
     * Boolean and second element a
     * HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>.
     */
    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail() {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunk_AccountDetail();
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue.  No data is
     * swapped from a_Grid2DSquareCell. For this to work accounting must be less
     * expesive in terms of data size than swapping data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell);
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunk_AccountDetail();
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue. The Chunk with
     * a_ChunkID from a_Grid2DSquareCell is not swapped. For this to work
     * accounting must be less expesive in terms of data size than swapping
     * data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell,
                    a_ChunkID);
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(AbstractGrid2DSquareCell,ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue.  No data is
     * swapped with a_ChunkID. For this to work accounting must be less
     * expesive in terms of data size than swapping data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_ChunkID);
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(ChunkID,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            ChunkID a_ChunkID) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_ChunkID);
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue.  No data is swapped
     * as identified by a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap. For
     * this to work accounting must be less expesive in terms of data size than
     * swapping data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap);
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * A method to ensure there is enough memory to continue.  No data is swapped
     * as identified by a_AbstractGrid2DSquareCell_ChunkID_HashSet_HashMap. For
     * this to work accounting must be less expesive in terms of data size than
     * swapping data!
     * @param handleOutOfMemoryError
     * @return HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> identifying
     * chunks swapped.
     */
    @Override
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            Object[] test = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet);
            if (test == null) {
                return null;
            }
            boolean test0 = (Boolean) test[0];
            if (!test0) {
                String message = new String(
                        "Warning! Not enough data to swap in "
                        + this.getClass().getName()
                        + ".tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(AbstractGrid2DSquareCell,HashSet<ChunkID>,boolean)");
                System.out.println(message);
                // Set to exit method with OutOfMemoryError
                handleOutOfMemoryError = false;
                throw new OutOfMemoryError(message);
            }
            return (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) test[1];
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected Object[] tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        if (getTotalFreeMemory() < Memory_Threshold) {
            Object[] result = new Object[2];
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result1 = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = null;
            while (getTotalFreeMemory() < Memory_Threshold) {
                potentialPartResult = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet);
                if (potentialPartResult.isEmpty()) {
                    result[0] = false;
                    result[1] = result1;
                    return result;
                } else {
                    combine(result1,
                            potentialPartResult);
                }
            }
            result[0] = true;
            result[1] = result1;
        }
        return null;
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught in this method then swap
     *     operations are initiated prior to retrying.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunks_AccountDetail(
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunks_AccountDetail();
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail();
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunks_AccountDetail();
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunks_AccountDetail() {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>();
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> partResult;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            partResult = a_Iterator.next().swapToFile_Grid2DSquareCellChunks_AccountDetail(HandleOutOfMemoryErrorFalse);
            combine(result,
                    partResult);
        }
        return result;
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught in this method then swap
     *     operations are initiated prior to retrying.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    public long swapToFile_Grid2DSquareCellChunks_Account(
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunks_Account();
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account();
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunk_Account();
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(handleOutOfMemoryError);
                result += swapToFile_Grid2DSquareCellChunks_Account(handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     */
    protected long swapToFile_Grid2DSquareCellChunks_Account() {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            result += a_Iterator.next()._Grids_Environment.swapToFile_Grid2DSquareCellChunks_Account(HandleOutOfMemoryErrorFalse);
        }
        dataToSwap = false;
        return result;
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught in this method then swap
     *     operations are initiated prior to retrying.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    public void swapToFile_Grid2DSquareCellChunks(
            boolean handleOutOfMemoryError) {
        try {
            boolean success = swapToFile_Grid2DSquareCellChunks();
            try {
                if (!success) {
                    tryToEnsureThereIsEnoughMemoryToContinue();
                } else {
                    tryToEnsureThereIsEnoughMemoryToContinue(handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunk_Account() < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(handleOutOfMemoryError);
                swapToFile_Grid2DSquareCellChunks();
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to swap all AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     */
    protected boolean swapToFile_Grid2DSquareCellChunks() {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            a_Iterator.next().swapToFile_Grid2DSquareCellChunks();
        }
        dataToSwap = false;
        return true;
    }

    /**
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     * This is the lowest level of OutOfMemoryError handling in this class.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param handleOutOfMemoryError
     *   If true then OutOfMemoryErrors are caught in this method then swap
     *     operations are initiated prior to retrying.
     *   If false then OutOfMemoryErrors are caught and thrown.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunk_AccountDetail(
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunk_AccountDetail();
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail();
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunk_AccountDetail();
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public void swapToFile_Grid2DSquareCellChunk(
            boolean handleOutOfMemoryError) {
        try {
            boolean success = swapToFile_Grid2DSquareCellChunk();
            try {
                if (!success) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account();
                    if (account != null) {
                        if (!(Boolean) account[0]) {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    tryToEnsureThereIsEnoughMemoryToContinue(handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunk_Account() < 1) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(handleOutOfMemoryError);
                // No need for recursive call: swapToFile_Grid2DSquareCellChunk(handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     */
    protected boolean swapToFile_Grid2DSquareCellChunk() {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            if (a_Iterator.next().swapToFile_Grid2DSquareCellChunk_Account() < 1) {
                return false;
            } else {
                return true;
            }
        }
        dataToSwap = false;
        return false;
    }

    public long swapToFile_Grid2DSquareCellChunk_Account(
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunk_Account();
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account();
                    if (account != null) {
                        if (!(Boolean) account[0]) {
                            throw new OutOfMemoryError();
                        } else {
                            result += (Long) account[1];
                        }
                    }
                } else {
                    long account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            handleOutOfMemoryError);
                    result += account;
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunk_Account();
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected long swapToFile_Grid2DSquareCellChunk_Account() {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            if (a_Iterator.next().swapToFile_Grid2DSquareCellChunk_Account() > 0) {
                return 1L;
            }
        }
        dataToSwap = false;
        return 0L;
    }

    /**
     * Swap to File any AbstractGrid2DSquareCell.Chunk in
     * this._AbstractGrid2DSquareCell_HashSet
     * except one in a_AbstractGrid2DSquareCell.
     * @param a_AbstractGrid2DSquareCell
     */
    public void swapToFile_Grid2DSquareCellChunkExcept(
            AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            boolean success = swapToFile_Grid2DSquareCellChunkExcept(
                    a_AbstractGrid2DSquareCell);
            try {
                if (!success) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_AbstractGrid2DSquareCell);
                    if (account != null) {
                        if (!(Boolean) account[0]) {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    tryToEnsureThereIsEnoughMemoryToContinue(
                            a_AbstractGrid2DSquareCell,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                if (swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_AbstractGrid2DSquareCell) < 1L) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_AbstractGrid2DSquareCell,
                        handleOutOfMemoryError);
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Swap to File any AbstractGrid2DSquareCell.Chunk in
     * this._AbstractGrid2DSquareCell_HashSet
     * except one in a_AbstractGrid2DSquareCell.
     * @param a_AbstractGrid2DSquareCell
     */
    protected boolean swapToFile_Grid2DSquareCellChunkExcept(
            AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell) {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_AbstractGrid2DSquareCell;
        while (a_Iterator.hasNext()) {
            b_AbstractGrid2DSquareCell = a_Iterator.next();
            if (b_AbstractGrid2DSquareCell != a_AbstractGrid2DSquareCell) {
                if (b_AbstractGrid2DSquareCell.swapToFile_Grid2DSquareCellChunk_Account() > 0) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * Modifies toGetCombined by adding all mapping from toCombine if they have
     * new keys. If they don't then this adds the contents of the values
     * @param toGetCombined
     * @param toCombine
     */
    public static void combine(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> toGetCombined,
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> toCombine) {
        if (toCombine != null) {
            if (!toCombine.isEmpty()) {
                Set<AbstractGrid2DSquareCell> toGetCombined_KeySet = toGetCombined.keySet();
                Set<AbstractGrid2DSquareCell> toCombine_KeySet = toCombine.keySet();
                Iterator<AbstractGrid2DSquareCell> toCombine_KeySet_Iterator = toCombine_KeySet.iterator();
                AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell;
                while (toCombine_KeySet_Iterator.hasNext()) {
                    a_AbstractGrid2DSquareCell = toCombine_KeySet_Iterator.next();
                    if (toGetCombined_KeySet.contains(a_AbstractGrid2DSquareCell)) {
                        toGetCombined.get(a_AbstractGrid2DSquareCell).addAll(toCombine.get(a_AbstractGrid2DSquareCell));
                    } else {
                        toGetCombined.put(a_AbstractGrid2DSquareCell, toCombine.get(a_AbstractGrid2DSquareCell));
                    }
                }
            }
        }
    }

    /**
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunk_AccountDetail() {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            AbstractGrid2DSquareCell a_Grid2DSquareCell = a_Iterator.next();
            result = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountDetail(
                    HandleOutOfMemoryErrorFalse);
            if (!result.isEmpty()) {
                return result;
            }
        }
        dataToSwap = false;
        return null;
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in with AbstractGrid2DSquareCell.ChunkID = _ChunkID.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                    swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                    a_ChunkID);
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_ChunkID,
                            handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result =
                        swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_ChunkID);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in with AbstractGrid2DSquareCell.ChunkID = _ChunkID.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            ChunkID a_ChunkID) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell;
        while (a_Iterator.hasNext()) {
            a_AbstractGrid2DSquareCell = a_Iterator.next();
            result = a_AbstractGrid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                    a_ChunkID);
            if (!result.isEmpty()) {
                HashSet<ChunkID> a_ChunkID_HashSet = new HashSet<ChunkID>(1);
                a_ChunkID_HashSet.add(a_ChunkID);
                result.put(
                        a_AbstractGrid2DSquareCell,
                        a_ChunkID_HashSet);
                return result;
            }
        }
        return null;
    }

    public long swapToFile_Grid2DSquareCellChunkExcept_Account(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                    a_ChunkID);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_ChunkID,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            result += tryToEnsureThereIsEnoughMemoryToContinue_Account(handleOutOfMemoryError);
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result =
                        swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_ChunkID);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in with AbstractGrid2DSquareCell.ChunkID = _ChunkID.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    protected long swapToFile_Grid2DSquareCellChunkExcept_Account(
            ChunkID a_ChunkID) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell;
        while (a_Iterator.hasNext()) {
            a_AbstractGrid2DSquareCell = a_Iterator.next();
            result += a_AbstractGrid2DSquareCell._Grids_Environment.swapToFile_Grid2DSquareCellChunkExcept_Account(
                    a_ChunkID);
            if (result > 0L) {
                return result;
            }
        }
        return result;
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in with AbstractGrid2DSquareCell.ChunkID = _ChunkID.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    protected void swapToFile_Grid2DSquareCellChunkExcept(
            ChunkID a_ChunkID) {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_AbstractGrid2DSquareCell;
        while (a_Iterator.hasNext()) {
            a_AbstractGrid2DSquareCell = a_Iterator.next();
            if (a_AbstractGrid2DSquareCell._Grids_Environment.swapToFile_Grid2DSquareCellChunkExcept_Account(a_ChunkID) > 0) {
                return;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell_ChunkIDHashSet.
     * @param a_Grid2DSquareCell_ChunkIDHashSet HashMap with AbstractGrid2DSquareCell as
     * keys and a respective HashSet of AbstractGrid2DSquareCell.ChunkIDs. Identifying
     * those ChunkIDs not to be swapped from the AbstractGrid2DSquareCell.
     * TODO
     * tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(<AbstractGrid2DSquareCell, HashSet<ChunkID>>,boolean);
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkIDHashSet,
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                    a_Grid2DSquareCell_ChunkIDHashSet);
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_Grid2DSquareCell_ChunkIDHashSet);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_Grid2DSquareCell_ChunkIDHashSet,
                            handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell_ChunkIDHashSet);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                init_MemoryReserve(
                        a_Grid2DSquareCell_ChunkIDHashSet,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell_ChunkIDHashSet.
     * @param _Grid2DSquareCell_ChunkIDHashSet HashMap with AbstractGrid2DSquareCell as
     * keys and a respective HashSet of AbstractGrid2DSquareCell.ChunkIDs. Identifying
     * those ChunkIDs not to be swapped from the AbstractGrid2DSquareCell.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkID_HashSet_HashMap) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_Grid2DSquareCell;
        HashSet<ChunkID> result_ChunkID_HashSet = new HashSet<ChunkID>(1);
        HashSet<ChunkID> a_ChunkID_HashSet;
        ChunkID a_ChunkID;
        while (a_Iterator.hasNext()) {
            a_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell_ChunkID_HashSet_HashMap.containsKey(a_Grid2DSquareCell)) {
                a_ChunkID_HashSet = a_Grid2DSquareCell_ChunkID_HashSet_HashMap.get(a_Grid2DSquareCell);
                a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountChunk(
                        a_ChunkID_HashSet,
                        HandleOutOfMemoryErrorFalse);
                if (a_ChunkID != null) {
                    result_ChunkID_HashSet.add(a_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            }
            a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
            if (a_ChunkID != null) {
                result_ChunkID_HashSet.add(a_ChunkID);
                result.put(
                        a_Grid2DSquareCell,
                        result_ChunkID_HashSet);
                return result;
            }
        }
        return result; // If we get here then nothing could be swapped.
    }

    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashSet<ChunkID> result_ChunkID_HashSet = new HashSet<ChunkID>(1);
        ChunkID b_ChunkID;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell == b_Grid2DSquareCell) {
                b_ChunkID = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountChunk(
                        a_ChunkID_HashSet,
                        HandleOutOfMemoryErrorFalse);
                if (b_ChunkID != null) {
                    result_ChunkID_HashSet.add(b_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            } else {
                b_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
                if (b_ChunkID != null) {
                    result_ChunkID_HashSet.add(b_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            }
        }
        return result; // If we get here then nothing could be swapped.
    }

    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashSet<ChunkID> result_ChunkID_HashSet = new HashSet<ChunkID>(1);
        ChunkID b_ChunkID;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell == b_Grid2DSquareCell) {
                b_ChunkID = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountChunk(
                        a_ChunkID,
                        HandleOutOfMemoryErrorFalse);
                if (b_ChunkID != null) {
                    result_ChunkID_HashSet.add(b_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            } else {
                b_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
                if (b_ChunkID != null) {
                    result_ChunkID_HashSet.add(b_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            }
        }
        return result; // If we get here then nothing could be swapped.
    }

    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>(1);
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashSet<ChunkID> result_ChunkID_HashSet = new HashSet<ChunkID>(1);
        ChunkID b_ChunkID;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell != b_Grid2DSquareCell) {
                b_ChunkID = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
                if (b_ChunkID != null) {
                    result_ChunkID_HashSet.add(b_ChunkID);
                    result.put(
                            a_Grid2DSquareCell,
                            result_ChunkID_HashSet);
                    return result;
                }
            }
        }
        return result; // If we get here then nothing could be swapped.
    }

    protected long swapToFile_Grid2DSquareCellChunkExcept_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkID_HashSet_HashMap) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_Grid2DSquareCell;
        HashSet<ChunkID> a_ChunkID_HashSet;
        ChunkID a_ChunkID;
        while (a_Iterator.hasNext()) {
            a_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell_ChunkID_HashSet_HashMap.containsKey(a_Grid2DSquareCell)) {
                a_ChunkID_HashSet = a_Grid2DSquareCell_ChunkID_HashSet_HashMap.get(a_Grid2DSquareCell);
                a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountChunk(
                        a_ChunkID_HashSet,
                        HandleOutOfMemoryErrorFalse);
                if (a_ChunkID != null) {
                    return 1L;
                }
            }
            a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
            if (a_ChunkID != null) {
                return 1L;
            }
        }
        return result; // If we get here then nothing could be swapped.
    }

    protected void swapToFile_Grid2DSquareCellChunkExcept(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkID_HashSet_HashMap) {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_Grid2DSquareCell;
        HashSet<ChunkID> result_ChunkID_HashSet = new HashSet<ChunkID>(1);
        HashSet<ChunkID> a_ChunkID_HashSet;
        ChunkID a_ChunkID;
        while (a_Iterator.hasNext()) {
            a_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell_ChunkID_HashSet_HashMap.containsKey(a_Grid2DSquareCell)) {
                a_ChunkID_HashSet = a_Grid2DSquareCell_ChunkID_HashSet_HashMap.get(a_Grid2DSquareCell);
                a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_AccountChunk(
                        a_ChunkID_HashSet,
                        HandleOutOfMemoryErrorFalse);
                if (a_ChunkID != null) {
                    return;
                }
            }
            a_ChunkID = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
            if (a_ChunkID != null) {
                result_ChunkID_HashSet.add(a_ChunkID);
                return;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell with AbstractGrid2DSquareCell._ChunkID
     * in a_ChunkID_HashSet.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     */
    public long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID_HashSet);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID_HashSet);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID_HashSet,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID_HashSet,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell with AbstractGrid2DSquareCell._ChunkID
     * in a_ChunkID_HashSet.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     */
    protected long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashMap<ChunkID, AbstractGrid2DSquareCellChunk> b_ChunkID_AbstractGrid2DSquareCellChunk_HashMap;
        Set<ChunkID> b_ChunkID_Set;
        Iterator<ChunkID> b_Iterator;
        ChunkID b_ChunkID;
        AbstractGrid2DSquareCellChunk b_AbstractGrid2DSquareCellChunk;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                b_ChunkID_AbstractGrid2DSquareCellChunk_HashMap = b_Grid2DSquareCell._ChunkID_AbstractGrid2DSquareCellChunk_HashMap;
                b_ChunkID_Set = b_ChunkID_AbstractGrid2DSquareCellChunk_HashMap.keySet();
                b_Iterator = b_ChunkID_Set.iterator();
                while (b_Iterator.hasNext()) {
                    b_ChunkID = b_Iterator.next();
                    if (!a_ChunkID_HashSet.contains(b_ChunkID)) {
                        //Check it can be swapped
                        b_AbstractGrid2DSquareCellChunk = b_ChunkID_AbstractGrid2DSquareCellChunk_HashMap.get(b_ChunkID);
                        if (b_AbstractGrid2DSquareCellChunk != null) {
                            b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk(b_ChunkID);
                            return 1;
                        }
                    }
                }
            }
        }
        return 0L;
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for that in _Grid2DSquareCell with AbstractGrid2DSquareCell._ChunkID
     * _ChunkID.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    public long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for that in _Grid2DSquareCell with AbstractGrid2DSquareCell._ChunkID
     * _ChunkID.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be swapped.
     */
    protected long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                a_Grid2DSquareCell);
        if (result < 1L) {
            result = a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunkExcept_Account(a_ChunkID);
        }
        return result;
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     */
    public long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                    a_Grid2DSquareCell);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * Attempts to swap any AbstractGrid2DSquareCellChunk in this._AbstractGrid2DSquareCell_HashSet
     * except for those in _Grid2DSquareCell.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     */
    protected long swapToFile_Grid2DSquareCellChunkExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                ChunkID a_ChunkID = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunk_AccountChunk();
                if (a_ChunkID != null) {
                    return 1L;
                }
            }
        }
        return 0L;
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be
     * swapped.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                    a_ChunkID);
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(a_ChunkID, handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_ChunkID);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                potentialPartResult = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be
     * swapped.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            ChunkID a_ChunkID) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>();
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        while (a_Iterator.hasNext()) {
            AbstractGrid2DSquareCell a_Grid2DSquareCell = a_Iterator.next();
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                    a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                    a_ChunkID);
            combine(result,
                    potentialPartResult);
        }
        return result;
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * swapped.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                    a_Grid2DSquareCell);
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_Grid2DSquareCell);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(a_Grid2DSquareCell, handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                        init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                potentialPartResult = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>();
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                potentialPartResult = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_AccountDetail();
                combine(result,
                        potentialPartResult);
            }
        }
        return result;
    }

    public long swapToFile_Grid2DSquareCellChunksExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunksExcept_Account(
                    a_Grid2DSquareCell);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                result += swapToFile_Grid2DSquareCellChunksExcept_Account(
                        a_Grid2DSquareCell,
                        handleOutOfMemoryError);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected long swapToFile_Grid2DSquareCellChunksExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                result += b_Grid2DSquareCell._Grids_Environment.swapToFile_Grid2DSquareCellChunks_Account();
            }
        }
        return result;
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be
     * swapped.
     */
    public HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                    a_Grid2DSquareCell,
                    a_ChunkID);
            try {
                if (result.isEmpty()) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_Grid2DSquareCell,
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            combine(result,
                                    (HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>) account[1]);
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult =
                            tryToEnsureThereIsEnoughMemoryToContinue_AccountDetail(
                            a_Grid2DSquareCell,
                            a_ChunkID,
                            handleOutOfMemoryError);
                    combine(result,
                            potentialPartResult);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = swapToFile_Grid2DSquareCellChunkExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (result.isEmpty()) {
                    throw a_OutOfMemoryError;
                }
                HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult = init_MemoryReserve_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                potentialPartResult = swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                        a_Grid2DSquareCell,
                        a_ChunkID,
                        handleOutOfMemoryError);
                combine(result,
                        potentialPartResult);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    public long swapToFile_Grid2DSquareCellChunksExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunksExcept_Account(
                    a_Grid2DSquareCell,
                    a_ChunkID);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell,
                            a_ChunkID,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_ChunkID,
                        handleOutOfMemoryError);
                result += swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell,
                        a_ChunkID);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected long swapToFile_Grid2DSquareCellChunksExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                result += b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_Account();
            } else {
                result += b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunksExcept_Account(a_ChunkID);
            }
        }
        return result;
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkID
     * _ChunkID.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * @param a_ChunkID The AbstractGrid2DSquareCell.ChunkID not to be
     * swapped.
     */
    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            ChunkID a_ChunkID) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>();
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell == a_Grid2DSquareCell) {
                potentialPartResult = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                        a_ChunkID);
                combine(result,
                        potentialPartResult);
            } else {
                potentialPartResult = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_AccountDetail();
                combine(result,
                        potentialPartResult);
            }
        }
        return result;
    }

    protected HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> result = new HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>>();
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> potentialPartResult;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                potentialPartResult = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_AccountDetail();
                combine(result,
                        potentialPartResult);
            } else {
                potentialPartResult = b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunksExcept_AccountDetail(
                        a_ChunkID_HashSet);
                combine(result,
                        potentialPartResult);
            }
        }
        return result;
    }

    /**
     * Attempts to Swap all AbstractGrid2DSquareCell.ChunkIDs in
     * this._AbstractGrid2DSquareCell_HashSet except those with AbstractGrid2DSquareCell.ChunkIDs
     * in a_ChunkID_HashSet.
     * @return HashMap with:
     * key as the AbstractGrid2DSquareCell from which
     * the AbstractGrid2DSquareCellChunk was swapped; and,
     * value as the AbstractGrid2DSquareCellChunk._ChunkID swapped.
     * @param a_Grid2DSquareCell AbstractGrid2DSquareCell that's chunks are not to be swapped.
     * @param a_ChunkID_HashSet The AbstractGrid2DSquareCell.ChunkID not to be
     * swapped.
     */
    protected long swapToFile_Grid2DSquareCellChunksExcept_Account(
            AbstractGrid2DSquareCell a_Grid2DSquareCell,
            HashSet<ChunkID> a_ChunkID_HashSet) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = _AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell b_Grid2DSquareCell;
        Set<ChunkID> b_ChunkID_Set;
        while (a_Iterator.hasNext()) {
            b_Grid2DSquareCell = a_Iterator.next();
            if (b_Grid2DSquareCell != a_Grid2DSquareCell) {
                result += b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_Account();
            } else {
                b_ChunkID_Set = b_Grid2DSquareCell._ChunkID_AbstractGrid2DSquareCellChunk_HashMap.keySet();
                b_ChunkID_Set.removeAll(a_ChunkID_HashSet);
                result += b_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_Account(b_ChunkID_Set);
            }
        }
        return result;
    }

    /**
     */
    public long swapToFile_Grid2DSquareCellChunksExcept_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkID_HashSet_HashMap,
            boolean handleOutOfMemoryError) {
        try {
            long result = swapToFile_Grid2DSquareCellChunksExcept_Account(
                    a_Grid2DSquareCell_ChunkID_HashSet_HashMap);
            try {
                if (result < 1) {
                    Object[] account = tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell_ChunkID_HashSet_HashMap);
                    if (account != null) {
                        if ((Boolean) account[0]) {
                            result += (Long) account[1];
                        } else {
                            throw new OutOfMemoryError();
                        }
                    }
                } else {
                    result += tryToEnsureThereIsEnoughMemoryToContinue_Account(
                            a_Grid2DSquareCell_ChunkID_HashSet_HashMap,
                            handleOutOfMemoryError);
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Set handleOutOfMemoryError = false to exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                long result = swapToFile_Grid2DSquareCellChunkExcept_Account(
                        a_Grid2DSquareCell_ChunkID_HashSet_HashMap);
                if (result < 1L) {
                    throw a_OutOfMemoryError;
                }
                result += init_MemoryReserve_Account(
                        a_Grid2DSquareCell_ChunkID_HashSet_HashMap,
                        handleOutOfMemoryError);
                result += swapToFile_Grid2DSquareCellChunksExcept_Account(
                        a_Grid2DSquareCell_ChunkID_HashSet_HashMap);
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    protected long swapToFile_Grid2DSquareCellChunksExcept_Account(
            HashMap<AbstractGrid2DSquareCell, HashSet<ChunkID>> a_Grid2DSquareCell_ChunkID_HashSet_HashMap) {
        long result = 0L;
        Iterator<AbstractGrid2DSquareCell> a_Iterator = this._AbstractGrid2DSquareCell_HashSet.iterator();
        AbstractGrid2DSquareCell a_Grid2DSquareCell;
        HashSet<ChunkID> a_ChunkID_HashSet;
        while (a_Iterator.hasNext()) {
            a_Grid2DSquareCell = a_Iterator.next();
            if (a_Grid2DSquareCell_ChunkID_HashSet_HashMap.containsKey(a_Grid2DSquareCell)) {
                a_ChunkID_HashSet = a_Grid2DSquareCell_ChunkID_HashSet_HashMap.get(a_Grid2DSquareCell);
                result += a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunksExcept_Account(
                        a_ChunkID_HashSet);
            } else {
                result += a_Grid2DSquareCell.swapToFile_Grid2DSquareCellChunks_Account();
            }
        }
        return result;
    }

    public void swapToFile_Data() {
        swapToFile_Grid2DSquareCellChunks();
    }

    public void swapToFile_Data(boolean handleOutOfMemoryError) {
        swapToFile_Grid2DSquareCellChunks();
    }

    @Override
    public boolean swapToFile_DataAny(boolean handleOutOfMemoryError) {
        try {
            boolean result = swapToFile_Grid2DSquareCellChunk();
            try {
                if (!tryToEnsureThereIsEnoughMemoryToContinue()) {
                    throw new OutOfMemoryError();
                }
            } catch (OutOfMemoryError a_OutOfMemoryError) {
                // Exit method by throwing OutOfMemoryError
                handleOutOfMemoryError = false;
                throw a_OutOfMemoryError;
            }
            return result;
        } catch (OutOfMemoryError a_OutOfMemoryError) {
            if (handleOutOfMemoryError) {
                clear_MemoryReserve();
                boolean result = swapToFile_DataAny(
                        HandleOutOfMemoryErrorFalse);
                init_MemoryReserve();
                return result;
            } else {
                throw a_OutOfMemoryError;
            }
        }
    }

    @Override
    public boolean swapToFile_DataAny() {
        return swapToFile_Grid2DSquareCellChunk();
    }

    protected boolean dataToSwap = true;

    public boolean isDataToSwap() {
        return dataToSwap;
    }

}
